// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'acThreadSafeLog.pas' rev: 6.00

#ifndef acThreadSafeLogHPP
#define acThreadSafeLogHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <acSendMail.hpp>	// Pascal unit
#include <acInet.hpp>	// Pascal unit
#include <acClasses.hpp>	// Pascal unit
#include <WinSock.hpp>	// Pascal unit
#include <StdCtrls.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Acthreadsafelog
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TacThreadSafeLogSendMailProperties;
class PASCALIMPLEMENTATION TacThreadSafeLogSendMailProperties : public Acsendmail::TacSendMailProperties 
{
	typedef Acsendmail::TacSendMailProperties inherited;
	
private:
	unsigned FLimit;
	
__published:
	__property unsigned Limit = {read=FLimit, write=FLimit, default=0};
public:
	#pragma option push -w-inl
	/* TacCustomSendMailProperties.Create */ inline __fastcall virtual TacThreadSafeLogSendMailProperties(Classes::TComponent* aOwner) : Acsendmail::TacSendMailProperties(aOwner) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TacThreadSafeLogSendMailProperties(void) { }
	#pragma option pop
	
};


#pragma option push -b-
enum TacThreadSafeLogOption { putTickStamp, putTimeStamp, putThreadID };
#pragma option pop

typedef Set<TacThreadSafeLogOption, putTickStamp, putThreadID>  TacThreadSafeLogOptions;

typedef void __fastcall (__closure *TacThreadSafeLogCustomPrefixEvent)(System::TObject* Sender, AnsiString &Prefix);

typedef void __fastcall (__closure *TacThreadSafeLogMaxSizeReachedEvent)(System::TObject* Sender, bool &ClearLog);

class DELPHICLASS TacThreadSafeLog;
class PASCALIMPLEMENTATION TacThreadSafeLog : public Acclasses::TacComponent 
{
	typedef Acclasses::TacComponent inherited;
	
private:
	AnsiString FDateTimeFormat;
	AnsiString FFileName;
	Stdctrls::TCustomMemo* FMemo;
	bool FFlushBuffers;
	bool FLogToFile;
	bool FLogToMemo;
	TacThreadSafeLogOptions FOptions;
	unsigned FMaxSize;
	TacThreadSafeLogSendMailProperties* FSendMail;
	unsigned FFileHandle;
	_RTL_CRITICAL_SECTION FLock;
	unsigned FStartTime;
	unsigned FMessagesSent;
	TacThreadSafeLogCustomPrefixEvent FOnCustomPrefix;
	Classes::TNotifyEvent FOnFileWriteError;
	TacThreadSafeLogMaxSizeReachedEvent FOnMaxSizeReached;
	void __fastcall SetFileName(const AnsiString Value);
	void __fastcall SetMemo(Stdctrls::TCustomMemo* Value);
	void __fastcall SetLogToFile(bool Value);
	bool __fastcall IsNotDefaultTimeFormat(void);
	
protected:
	virtual void __fastcall Loaded(void);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation);
	void __fastcall Open(void);
	void __fastcall Close(void);
	bool __fastcall RecreateFile(void);
	void __fastcall PrepareLogMessage(AnsiString &Text);
	
public:
	__fastcall virtual TacThreadSafeLog(Classes::TComponent* aOwner);
	__fastcall virtual ~TacThreadSafeLog(void);
	void __fastcall Log(AnsiString Text, bool SendEmail = false, unsigned LinesToSend = (unsigned)(0x64))/* overload */;
	void __fastcall Log(__int64 Int, bool SendEmail = false, unsigned LinesToSend = (unsigned)(0x64))/* overload */;
	void __fastcall Log(Extended Ext, bool SendEmail = false, unsigned LinesToSend = (unsigned)(0x64))/* overload */;
	void __fastcall Flush(void);
	void __fastcall ClearLog(void);
	AnsiString __fastcall GetLastRecords(unsigned Count = (unsigned)(0x64));
	bool __fastcall EmailLastRecords(unsigned Count = (unsigned)(0x64));
	__property unsigned FileHandle = {read=FFileHandle, nodefault};
	__property unsigned MessagesSent = {read=FMessagesSent, nodefault};
	
__published:
	__property AnsiString FileName = {read=FFileName, write=SetFileName};
	__property Stdctrls::TCustomMemo* Memo = {read=FMemo, write=SetMemo};
	__property AnsiString DateTimeFormat = {read=FDateTimeFormat, write=FDateTimeFormat, stored=IsNotDefaultTimeFormat};
	__property bool FlushBuffers = {read=FFlushBuffers, write=FFlushBuffers, default=0};
	__property bool LogToFile = {read=FLogToFile, write=SetLogToFile, default=1};
	__property bool LogToMemo = {read=FLogToMemo, write=FLogToMemo, default=1};
	__property unsigned MaxSize = {read=FMaxSize, write=FMaxSize, default=0};
	__property TacThreadSafeLogOptions Options = {read=FOptions, write=FOptions, default=2};
	__property TacThreadSafeLogSendMailProperties* SendMail = {read=FSendMail, write=FSendMail};
	__property TacThreadSafeLogCustomPrefixEvent OnCustomPrefix = {read=FOnCustomPrefix, write=FOnCustomPrefix};
	__property Classes::TNotifyEvent OnFileWriteError = {read=FOnFileWriteError, write=FOnFileWriteError};
	__property TacThreadSafeLogMaxSizeReachedEvent OnMaxSizeReached = {read=FOnMaxSizeReached, write=FOnMaxSizeReached};
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE TacThreadSafeLog* MasterLog;
extern PACKAGE void __fastcall Log(const AnsiString Text);
extern PACKAGE AnsiString __fastcall LoadLogAndFilterByThreadID(const AnsiString LogFileName, unsigned ThreadID);

}	/* namespace Acthreadsafelog */
using namespace Acthreadsafelog;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// acThreadSafeLog
