// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'acTimer.pas' rev: 6.00

#ifndef acTimerHPP
#define acTimerHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <acClasses.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Actimer
{
//-- type declarations -------------------------------------------------------
typedef Set<Shortint, 0, 59>  TacCronSet;

#pragma option push -b-
enum TacCronGroups { crSec, crMin, crHour, crDay, crMonth, crDoW };
#pragma option pop

class DELPHICLASS TacCron;
class PASCALIMPLEMENTATION TacCron : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	TacCronSet Groups[6];
	
public:
	void __fastcall Init( System::ShortString &CronMask);
	bool __fastcall IsCron(const _SYSTEMTIME &CheckTime);
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TacCron(void) : System::TObject() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TacCron(void) { }
	#pragma option pop
	
};


class DELPHICLASS TacCustomTimer;
class PASCALIMPLEMENTATION TacCustomTimer : public Acclasses::TacHandleComponent 
{
	typedef Acclasses::TacHandleComponent inherited;
	
private:
	bool FActive;
	unsigned FAlertsCount;
	
protected:
	virtual void __fastcall WndProc(Messages::TMessage &Message);
	void __fastcall Tick(void);
	virtual void __fastcall DoTimer(void);
	virtual bool __fastcall IsActive(void);
	
public:
	__fastcall virtual TacCustomTimer(Classes::TComponent* aOwner);
	__fastcall virtual ~TacCustomTimer(void);
	virtual void __fastcall Reset(void);
	__property bool Active = {read=FActive, write=FActive, default=1};
	__property unsigned AlertsCount = {read=FAlertsCount, nodefault};
};


class DELPHICLASS TacCustomAccurateTimer;
class PASCALIMPLEMENTATION TacCustomAccurateTimer : public TacCustomTimer 
{
	typedef TacCustomTimer inherited;
	
private:
	unsigned FCurrent;
	Classes::TNotifyEvent FOnTimer;
	
protected:
	unsigned FInterval;
	virtual void __fastcall DoTimer(void);
	void __fastcall Update(unsigned Increment);
	
public:
	__fastcall virtual TacCustomAccurateTimer(Classes::TComponent* aOwner);
	virtual void __fastcall Reset(void);
	__property unsigned Interval = {read=FInterval, write=FInterval, default=1000};
	__property Classes::TNotifyEvent OnTimer = {read=FOnTimer, write=FOnTimer};
public:
	#pragma option push -w-inl
	/* TacCustomTimer.Destroy */ inline __fastcall virtual ~TacCustomAccurateTimer(void) { }
	#pragma option pop
	
};


class DELPHICLASS TacAccurateTimer;
class PASCALIMPLEMENTATION TacAccurateTimer : public TacCustomAccurateTimer 
{
	typedef TacCustomAccurateTimer inherited;
	
__published:
	__property Active  = {default=1};
	__property Interval  = {default=1000};
	__property OnTimer ;
public:
	#pragma option push -w-inl
	/* TacCustomAccurateTimer.Create */ inline __fastcall virtual TacAccurateTimer(Classes::TComponent* aOwner) : TacCustomAccurateTimer(aOwner) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TacCustomTimer.Destroy */ inline __fastcall virtual ~TacAccurateTimer(void) { }
	#pragma option pop
	
};


class DELPHICLASS TacCronJob;
class PASCALIMPLEMENTATION TacCronJob : public TacCustomTimer 
{
	typedef TacCustomTimer inherited;
	
private:
	AnsiString FCronMask;
	Classes::TNotifyEvent FOnAlert;
	TacCron* FCron;
	_SYSTEMTIME FLastCronTime;
	void __fastcall SetCronMask(const AnsiString Value);
	System::TDateTime __fastcall GetLastTime(void);
	
protected:
	virtual void __fastcall DoTimer(void);
	void __fastcall Update(const _SYSTEMTIME &CheckTime);
	
public:
	__fastcall virtual TacCronJob(Classes::TComponent* aOwner);
	__fastcall virtual ~TacCronJob(void);
	__property _SYSTEMTIME LastCronTime = {read=FLastCronTime};
	__property System::TDateTime LastTime = {read=GetLastTime};
	
__published:
	__property Active  = {default=1};
	__property AnsiString CronMask = {read=FCronMask, write=SetCronMask};
	__property Classes::TNotifyEvent OnAlert = {read=FOnAlert, write=FOnAlert};
};


class DELPHICLASS TacTimerManager;
class PASCALIMPLEMENTATION TacTimerManager : public Classes::TThread 
{
	typedef Classes::TThread inherited;
	
private:
	Acclasses::TacThreadList* TimerList;
	Acclasses::TacThreadList* AlarmList;
	unsigned LastTicks;
	Word LastSecond;
	
protected:
	virtual void __fastcall Execute(void);
	
public:
	__fastcall TacTimerManager(void);
	__fastcall virtual ~TacTimerManager(void);
	void __fastcall AddTimer(TacCustomTimer* Item);
	void __fastcall DeleteTimer(TacCustomTimer* Item, bool ReleaseInstance = false);
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE TacTimerManager* TimerManager;

}	/* namespace Actimer */
using namespace Actimer;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// acTimer
